// Generated by CoffeeScript 1.8.0

/* Copyright Information  
	 * @author	Tim Düsterhus  
	 * @copyright	2010-2014 Tim Düsterhus  
	 * @license	Creative Commons Attribution-NonCommercial-ShareAlike <http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode>  
	 * @package	be.bastelstu.chat
 */

(function() {
  (function($, window) {
    "use strict";
    var Action, Attachment, Chat, addListener, autocomplete, chatSession, clearChannel, closePrivateChannel, console, errorVisible, events, fileUploaded, freeTheFish, getMessages, handleMessages, handleScroll, handleUsers, hiddenTopics, hideInputError, hidePrivateChannelTopic, init, initialized, inputErrorHidingTimer, insertText, isActive, isJoining, join, lastMessage, loading, loadingAwaiting, markedMessages, messageContainerSize, newMessageCount, notify, openChannel, openPrivateChannel, overlaySmileyList, pe, refreshRoomList, remainingFailures, removeListener, roomList, scrollUpNotifications, showError, showInputError, userList, userListSize, v, _ref;
    console = {
      log: function(message) {
        if (typeof production === "undefined" || production === null) {
          return window.console.log("[be.bastelstu.Chat] " + message);
        }
      },
      warn: function(message) {
        if (typeof production === "undefined" || production === null) {
          return window.console.warn("[be.bastelstu.Chat] " + message);
        }
      },
      error: function(message) {
        if (typeof production === "undefined" || production === null) {
          return window.console.error("[be.bastelstu.Chat] " + message);
        }
      }
    };
    isActive = true;
    newMessageCount = 0;
    scrollUpNotifications = false;
    chatSession = Date.now();
    userList = {
      current: {},
      allTime: {}
    };
    roomList = {
      active: {},
      available: {}
    };
    hiddenTopics = {};
    hidePrivateChannelTopic = false;
    isJoining = false;
    fileUploaded = false;
    errorVisible = false;
    inputErrorHidingTimer = null;
    lastMessage = null;
    openChannel = 0;
    messageContainerSize = 0;
    userListSize = 0;
    remainingFailures = 3;
    overlaySmileyList = null;
    markedMessages = {};
    events = {
      newMessage: $.Callbacks(),
      userMenu: $.Callbacks(),
      submit: $.Callbacks()
    };
    pe = {
      getMessages: null,
      refreshRoomList: null,
      fish: null
    };
    loading = false;
    loadingAwaiting = false;
    autocomplete = {
      offset: 0,
      value: null,
      caret: 0
    };
    v = {
      titleTemplate: null,
      messageTemplate: null,
      userTemplate: null,
      config: null
    };
    initialized = false;
    init = function(roomID, config, titleTemplate, messageTemplate, userTemplate, userMenuTemplate) {
      if (initialized) {
        return false;
      }
      initialized = true;
      userListSize = $('#timsChatUserList').height();
      v.config = config;
      v.titleTemplate = titleTemplate;
      v.messageTemplate = messageTemplate;
      v.userTemplate = userTemplate;
      v.userMenuTemplate = userMenuTemplate;
      console.log('Initializing');
      $(window).focus(function() {
        var _ref;
        if ((((_ref = roomList.active) != null ? _ref.title : void 0) != null) && roomList.active.title.trim() !== '') {
          document.title = v.titleTemplate.fetch(roomList.active);
        }
        newMessageCount = 0;
        return isActive = true;
      });
      $(window).blur(function() {
        return isActive = false;
      });
      $(window).on('beforeunload', function() {
        if (errorVisible) {
          return void 0;
        }
        new WCF.Action.Proxy({
          autoSend: true,
          data: {
            actionName: 'leave',
            className: 'chat\\data\\room\\RoomAction'
          },
          showLoadingOverlay: false,
          async: false,
          suppressErrors: true
        });
        return void 0;
      });
      $(window).resize(function() {
        if ($('html').hasClass('fullscreen')) {
          (function() {
            var freeSpace, verticalContentPadding, verticalSizeOfContentElements;
            verticalContentPadding = $('#content').innerHeight() - $('#content').height();
            verticalSizeOfContentElements = (function() {
              var height;
              height = 0;
              $('#content > *:visible').each(function(k, v) {
                return height += $(v).outerHeight();
              });
              return height;
            })();
            if (verticalSizeOfContentElements === 0) {
              return;
            }
            freeSpace = $('body').height() - verticalContentPadding - verticalSizeOfContentElements;
            return $('.timsChatMessageContainer').height($('.timsChatMessageContainer').height() + freeSpace);
          })();
          (function() {
            var freeSpace, sidebarHeight, verticalSidebarPadding, verticalUserListContainerPadding;
            verticalSidebarPadding = $('.sidebar').innerHeight() - $('.sidebar').height();
            verticalUserListContainerPadding = $('#timsChatUserListContainer').innerHeight() - $('#timsChatUserListContainer').height();
            sidebarHeight = $('.sidebar > div').height();
            freeSpace = $('body').height() - verticalSidebarPadding - verticalUserListContainerPadding - sidebarHeight;
            return $('#timsChatUserList').height($('#timsChatUserList').height() + freeSpace);
          })();
        }
        if ($('#timsChatAutoscroll').data('status')) {
          return $('.timsChatMessageContainer.active').scrollTop($('.timsChatMessageContainer.active').prop('scrollHeight'));
        }
      });
      $('.mobileSidebarToggleButton').on('click', function() {
        return $(window).resize();
      });
      $('#timsChatSmileyContainer').on('click', 'img', function() {
        return insertText(" " + ($(this).attr('alt')) + " ");
      });
      overlaySmileyList = $('<ul class="smileyList">').append($('#timsChatSmileyContainer .smileyList').clone().children());
      overlaySmileyList.on('click', 'img', function() {
        insertText(" " + ($(this).attr('alt')) + " ");
        return overlaySmileyList.wcfDialog('close');
      });
      $('#timsChatSmileyPopupButton').on('click', function() {
        overlaySmileyList.wcfDialog({
          title: WCF.Language.get('chat.global.smilies')
        });
        return overlaySmileyList.css({
          'max-height': $(window).height() - overlaySmileyList.parent().siblings('.dialogTitlebar').outerHeight(),
          'overflow': 'auto'
        });
      });
      $('#timsChatMessageTabMenu > .tabMenu').on('click', '.timsChatMessageTabMenuAnchor', function() {
        return openPrivateChannel($(this).data('userID'));
      });
      $('#timsChatForm').submit(function(event) {
        var text;
        event.preventDefault();
        text = $('#timsChatInput').val().trim();
        $('#timsChatInput').val('').focus().change();
        if (text.length === 0) {
          return false;
        }
        if (openChannel !== 0) {
          text = "/whisper " + userList.allTime[openChannel].username + ", " + text;
        }
        if (text.toLowerCase() === '/free the fish') {
          freeTheFish();
        }
        text = (function(text) {
          var obj;
          obj = {
            text: text
          };
          events.submit.fire(obj);
          return obj.text;
        })(text);
        return new WCF.Action.Proxy({
          autoSend: true,
          data: {
            actionName: 'send',
            className: 'chat\\data\\message\\MessageAction',
            parameters: {
              text: text,
              enableSmilies: $('#timsChatSmilies').data('status')
            }
          },
          showLoadingOverlay: false,
          success: function() {
            hideInputError();
            return getMessages();
          },
          failure: function(data) {
            var _ref, _ref1, _ref2;
            if (!(((data != null ? (_ref = data.returnValues) != null ? _ref.errorType : void 0 : void 0) != null) || ((data != null ? data.message : void 0) != null))) {
              return true;
            }
            showInputError((_ref1 = (data != null ? (_ref2 = data.returnValues) != null ? _ref2.errorType : void 0 : void 0)) != null ? _ref1 : data.message);
            return false;
          }
        });
      });
      $('#timsChatInput').keydown(function(event) {
        var afterComplete, beforeCaret, beforeComplete, command, commands, input, lastSpace, nextSpace, regex, toComplete, user, userID, users, _ref;
        switch (event.keyCode) {
          case 229:
            break;
          case $.ui.keyCode.TAB:
            event.preventDefault();
            input = $(this);
            if (autocomplete.value == null) {
              autocomplete.value = input.val();
            }
            if (autocomplete.caret == null) {
              autocomplete.caret = input.getCaret();
            }
            beforeCaret = autocomplete.value.substring(0, autocomplete.caret);
            lastSpace = beforeCaret.lastIndexOf(' ');
            beforeComplete = autocomplete.value.substring(0, lastSpace + 1);
            toComplete = autocomplete.value.substring(lastSpace + 1);
            nextSpace = toComplete.indexOf(' ');
            if (nextSpace === -1) {
              afterComplete = '';
            } else {
              afterComplete = toComplete.substring(nextSpace + 1);
              toComplete = toComplete.substring(0, nextSpace);
            }
            if (toComplete.length === 0) {
              return;
            }
            console.log("Autocompleting '" + toComplete + "'");
            if (beforeComplete === '' && (toComplete.substring(0, 1)) === '/') {
              regex = new RegExp("^" + (WCF.String.escapeRegExp(toComplete.substring(1))), "i");
              commands = (function() {
                var _i, _len, _ref, _results;
                _ref = v.config.installedCommands;
                _results = [];
                for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                  command = _ref[_i];
                  if (regex.test(command)) {
                    _results.push(command);
                  }
                }
                return _results;
              })();
              if (commands.length !== 0) {
                toComplete = '/' + commands[autocomplete.offset++ % commands.length] + ' ';
              }
            } else {
              regex = new RegExp("^" + (WCF.String.escapeRegExp(toComplete)), "i");
              users = [];
              _ref = userList.current;
              for (userID in _ref) {
                user = _ref[userID];
                if (regex.test(user.username)) {
                  users.push(user.username);
                }
              }
              if (users.length !== 0) {
                toComplete = users[autocomplete.offset++ % users.length] + ', ';
              }
            }
            input.val("" + beforeComplete + toComplete + afterComplete);
            return input.setCaret((beforeComplete + toComplete).length);
          default:
            return $('#timsChatInput').click();
        }
      });
      $('#timsChatInput').click(function() {
        return autocomplete = {
          offset: 0,
          value: null,
          caret: null
        };
      });
      $('#dropdownMenuContainer').on('click', '.jsTimsChatUserMenuQuery', function() {
        return openPrivateChannel($(this).parents('ul').data('userID'));
      });
      $('#dropdownMenuContainer').on('click', '.jsTimsChatUserMenuCommand', function() {
        var command;
        command = "/" + ($(this).data('command')) + " " + userList.current[$(this).parents('ul').data('userID')].username + ", ";
        if ($('#timsChatInput').val().match(new RegExp(WCF.String.escapeRegExp("^" + command), 'i'))) {
          return;
        }
        return insertText(command, {
          prepend: true
        });
      });
      $('#timsChatRoomListReloadButton').click(function() {
        return refreshRoomList();
      });
      $('#timsChatClear').click(function(event) {
        event.preventDefault();
        return clearChannel(openChannel);
      });
      $('.timsChatToggle').click(function(event) {
        var element;
        element = $(this);
        if (element.data('status') === 1) {
          element.data('status', 0);
          element.removeClass('active');
          element.attr('title', element.data('enableMessage'));
        } else {
          element.data('status', 1);
          element.addClass('active');
          element.attr('title', element.data('disableMessage'));
        }
        return $('#timsChatInput').focus();
      });
      $('#timsChatSmilies').click(function(event) {
        if ($(this).data('status')) {
          return $('#timsChatSmileyContainer').removeClass('invisible');
        } else {
          return $('#timsChatSmileyContainer').addClass('invisible');
        }
      });
      $('#timsChatFullscreen').click(function(event) {
        $('.dropdownMenu').data('orientationX', '');
        if ($(this).data('status')) {
          messageContainerSize = $('.timsChatMessageContainer').height();
          $('html').addClass('fullscreen');
          return $(window).resize();
        } else {
          $('.timsChatMessageContainer').height(messageContainerSize);
          $('#timsChatUserList').height(userListSize);
          $('html').removeClass('fullscreen');
          return $(window).resize();
        }
      });
      $('#timsChatMark').click(function(event) {
        if ($(this).data('status')) {
          return $('.timsChatMessageContainer').addClass('markEnabled');
        } else {
          return $('.timsChatMessageContainer').removeClass('markEnabled');
        }
      });
      $('#timsChatTopicCloser').on('click', function() {
        if (openChannel === 0) {
          hiddenTopics[roomList.active.roomID] = true;
        } else {
          hidePrivateChannelTopic = true;
        }
        $('#timsChatTopic').addClass('invisible');
        return $(window).resize();
      });
      $('#timsChatMessageTabMenu').on('click', '.jsChannelCloser', function() {
        return closePrivateChannel($(this).parent().data('userID'));
      });
      $(document).on('click', '.timsChatMessage .timsChatMessageMarker', function(event) {
        var checked, elem, messageID, parent;
        elem = $(event.target);
        parent = elem.parent();
        messageID = elem.attr('value');
        if (elem.is(':checked')) {
          markedMessages[messageID] = messageID;
          checked = true;
          parent.addClass('checked');
          parent.siblings().each(function(key, value) {
            checked = $(value).find('.timsChatMessageMarker').is(':checked');
            return checked;
          });
          if (checked) {
            elem.parents('.timsChatMessage').addClass('checked');
            return elem.parents('.timsChatTextContainer').siblings('.timsChatMessageGroupMarker').prop('checked', true);
          }
        } else {
          delete markedMessages[messageID];
          parent.removeClass('checked');
          elem.parents('.timsChatMessage').removeClass('checked');
          return elem.parents('.timsChatTextContainer').siblings('.timsChatMessageGroupMarker').prop('checked', false);
        }
      });
      $(document).on('click', '.timsChatMessageGroupMarker', function(event) {
        return $(event.target).siblings('.timsChatTextContainer').children('li').each(function(key, value) {
          var elem;
          elem = $(value).find('.timsChatMessageMarker');
          if ($(event.target).is(':checked')) {
            if (!elem.is(':checked')) {
              return elem.click();
            }
          } else {
            if (elem.is(':checked')) {
              return elem.click();
            }
          }
        });
      });
      $('#timsChatAutoscroll').click(function(event) {
        if ($(this).data('status')) {
          $('.timsChatMessageContainer.active').scrollTop($('.timsChatMessageContainer.active').prop('scrollHeight'));
          scrollUpNotifications = false;
          $("#timsChatMessageTabMenu > .tabMenu > ul > li.ui-state-active").removeClass('notify');
          return $(".timsChatMessageContainer.active").removeClass('notify');
        } else {
          return scrollUpNotifications = true;
        }
      });
      $('.timsChatMessageContainer.active').on('scroll', function(event) {
        event.stopPropagation();
        return handleScroll(event);
      });
      try {
        window.localStorage.setItem('be.bastelstu.chat.session', chatSession);
        $(window).on('storage', function(event) {
          if (event.originalEvent.key === 'be.bastelstu.chat.session') {
            if (parseInt(event.originalEvent.newValue) !== chatSession) {
              return showError(WCF.Language.get('chat.error.duplicateTab'));
            }
          }
        });
      } catch (_error) {}
      if (window.Notification != null) {
        $('#timsChatNotify').click(function(event) {
          if (!$(this).data('status')) {
            return;
          }
          if (window.Notification.permission !== 'granted') {
            return window.Notification.requestPermission(function(permission) {
              var _base;
              return (_base = window.Notification).permission != null ? _base.permission : _base.permission = permission;
            });
          }
        });
      }
      events.newMessage.add(notify);
      pe.refreshRoomList = new WCF.PeriodicalExecuter(refreshRoomList, 60e3);
      pe.getMessages = new WCF.PeriodicalExecuter(getMessages, v.config.reloadTime * 1e3);
      (function() {
        be.bastelstu.wcf.nodePush.onConnect(function() {
          console.log('Disabling periodic loading');
          return pe.getMessages.stop();
        });
        be.bastelstu.wcf.nodePush.onDisconnect(function() {
          console.log('Enabling periodic loading');
          getMessages();
          return pe.getMessages.resume();
        });
        be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.chat.newMessage', getMessages);
        be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.wcf.nodePush.tick60', getMessages);
        be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.chat.roomChange', refreshRoomList);
        be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.chat.join', refreshRoomList);
        return be.bastelstu.wcf.nodePush.onMessage('be.bastelstu.chat.leave', refreshRoomList);
      })();
      if (WCF.System.Mobile.UX._enabled) {
        $('#timsChatFullscreen').click();
      }
      join(roomID);
      $('#timsChatInput').enable().jCounter().focus();
      console.log("Finished initializing");
      return true;
    };
    showInputError = function(message) {
      $('#timsChatInputContainer').addClass('formError').find('.innerError').show().html(message);
      if (inputErrorHidingTimer != null) {
        clearTimeout(inputErrorHidingTimer);
      }
      return inputErrorHidingTimer = setTimeout(function() {
        return hideInputError();
      }, 5e3);
    };
    hideInputError = function() {
      if (inputErrorHidingTimer != null) {
        clearTimeout(inputErrorHidingTimer);
      }
      inputErrorHidingTimer = null;
      return $('#timsChatInputContainer').removeClass('formError').find('.innerError').hide();
    };
    freeTheFish = function() {
      var fish;
      if ($.wcfIsset('fish')) {
        return;
      }
      console.warn('Freeing the fish');
      fish = $("<div id=\"fish\"><span></span></div>");
      fish.direction = 'right';
      fish.css({
        position: 'fixed',
        top: '50%',
        left: '50%',
        zIndex: 0x7FFFFFFF,
        textShadow: '1px 1px rgb(0, 0, 0)'
      });
      fish.appendTo($('body'));
      fish.colors = ['78C5D6', '459ba8', '79C267', 'C5D647', 'F5D63D', 'F28C33', 'E868A2', 'BF62A6'];
      fish.colorIndex = 0;
      fish.texts = {
        right: '><((((\u00B0>',
        left: '<\u00B0))))><'
      };
      fish.fishes = {};
      $.each(fish.texts, function(key, value) {
        var html, i, index;
        fish.fishes[key] = [];
        index = 0;
        while (index < value.length) {
          html = $('<span/>');
          i = 0;
          $(value.split('')).each(function(key, value) {
            return $("<span>" + value + "</span>").css({
              color: '#' + fish.colors[(i++ + index) % fish.colors.length],
              textShadow: '1px 1px rgb(0, 0, 0)'
            }).appendTo(html);
          });
          fish.fishes[key][index++] = html;
        }
      });
      fish.find('> span').replaceWith(fish.fishes[fish.direction][0]);
      fish.updateRainbowText = function(key, value) {
        key = key || fish.direction;
        if (!((fish.fishes[key] != null) || (fish.texts[key] == null))) {
          return;
        }
        value = value || fish.colorIndex++ % fish.texts[key].length;
        return fish.find('> span').replaceWith(fish.fishes[key][value]);
      };
      fish.pePos = new WCF.PeriodicalExecuter(function() {
        var left, loops, top;
        loops = 0;
        while (true) {
          ++loops;
          left = Math.random() * 300 - 150;
          top = Math.random() * 300 - 150;
          if ((fish.position().top + top) > 0 && (fish.position().left + left + fish.width()) < $(window).width() && (fish.position().top + top + fish.height()) < $(window).height() && (fish.position().left + left) > 0) {
            break;
          } else if (loops === 10) {
            console.log('Magicarp used Splash for the 10th time in a row - it fainted!');
            fish.css({
              'top': '50%',
              'left': '50%'
            });
            break;
          }
        }
        if (left > 0 && fish.text() !== '><((((\u00B0>') {
          fish.direction = 'right';
          fish.updateRainbowText(null, fish.colorIndex % fish.texts.right.length);
        } else if (left < 0 && fish.text() !== '<\u00B0))))><') {
          fish.direction = 'left';
          fish.updateRainbowText(null, fish.colorIndex % fish.texts.left.length);
        }
        return fish.animate({
          top: fish.position().top + top,
          left: fish.position().left + left
        }, 1e3);
      }, 1.2e3);
      return fish.peColor = new WCF.PeriodicalExecuter(function() {
        return fish.updateRainbowText();
      }, .125e3);
    };
    getMessages = function() {
      return $.ajax(v.config.messageURL, {
        dataType: 'json',
        type: 'POST',
        success: function(data) {
          remainingFailures = 3;
          handleMessages(data.messages);
          handleUsers(data.users);
          return WCF.DOMNodeInsertedHandler.execute();
        },
        error: function() {
          console.error("Message loading failed, " + (--remainingFailures) + " remaining");
          if (remainingFailures <= 0) {
            freeTheFish();
            console.error('To many failures, aborting');
            return showError(WCF.Language.get('chat.error.onMessageLoad'));
          }
        },
        complete: function() {
          loading = false;
          if (loadingAwaiting) {
            loadingAwaiting = false;
            return getMessages();
          }
        },
        beforeSend: function() {
          if (loading) {
            loadingAwaiting = true;
            return false;
          }
          return loading = true;
        }
      });
    };
    handleMessages = function(messages) {
      var createNewMessage, li, message, messageContainerID, output, textContainer, _i, _len, _ref;
      for (_i = 0, _len = messages.length; _i < _len; _i++) {
        message = messages[_i];
        message.isInPrivateChannel = (message.type === v.config.messageTypes.WHISPER) && ($.wcfIsset("timsChatMessageContainer" + message.receiver) || $.wcfIsset("timsChatMessageContainer" + message.sender));
        events.newMessage.fire(message);
        createNewMessage = true;
        if ($('.timsChatMessage:last-child .timsChatTextContainer').is('ul') && lastMessage !== null && ((_ref = lastMessage.type) === v.config.messageTypes.NORMAL || _ref === v.config.messageTypes.WHISPER)) {
          if (lastMessage.type === message.type && lastMessage.sender === message.sender && lastMessage.receiver === message.receiver && lastMessage.isInPrivateChannel === message.isInPrivateChannel) {
            createNewMessage = false;
          }
        }
        if (message.type === v.config.messageTypes.CLEAR) {
          createNewMessage = true;
          clearChannel(0);
        }
        if (createNewMessage) {
          message.isFollowUp = false;
          output = v.messageTemplate.fetch({
            message: message,
            messageTypes: v.config.messageTypes
          });
          li = $('<li></li>');
          li.addClass('timsChatMessage');
          li.addClass("timsChatMessage" + message.type);
          li.addClass("user" + message.sender);
          if (message.sender === WCF.User.userID) {
            li.addClass('ownMessage');
          }
          li.append(output);
          if (message.isInPrivateChannel && message.sender === WCF.User.userID) {
            li.appendTo($("#timsChatMessageContainer" + message.receiver + " > ul"));
          } else if (message.isInPrivateChannel) {
            li.appendTo($("#timsChatMessageContainer" + message.sender + " > ul"));
          } else {
            li.appendTo($('#timsChatMessageContainer0 > ul'));
          }
        } else {
          message.isFollowUp = true;
          output = v.messageTemplate.fetch({
            message: message,
            messageTypes: v.config.messageTypes
          });
          if (message.isInPrivateChannel && message.sender === WCF.User.userID) {
            messageContainerID = message.receiver;
          } else if (message.isInPrivateChannel) {
            messageContainerID = message.sender;
          } else {
            messageContainerID = 0;
          }
          textContainer = $("#timsChatMessageContainer" + messageContainerID).find('.timsChatMessage:last-child .timsChatTextContainer');
          textContainer.append($(output).find('.timsChatTextContainer li:last-child'));
          textContainer.parents('.timsChatMessage').removeClass('checked');
          textContainer.siblings('.timsChatMessageGroupMarker').prop('checked', false);
        }
        lastMessage = message;
      }
      if ($('#timsChatAutoscroll').data('status') === 1) {
        return $('.timsChatMessageContainer.active').scrollTop($('.timsChatMessageContainer.active').prop('scrollHeight'));
      }
    };
    handleScroll = function(event) {
      var element, height, scrollHeight, scrollTop;
      element = $(event.target);
      if (element.hasClass('active')) {
        scrollTop = element.scrollTop();
        scrollHeight = element.prop('scrollHeight');
        height = element.innerHeight();
        if (scrollTop < scrollHeight - height - 25) {
          if ($('#timsChatAutoscroll').data('status') === 1) {
            scrollUpNotifications = true;
            $('#timsChatAutoscroll').click();
          }
        }
        if (scrollTop > scrollHeight - height - 10) {
          if ($('#timsChatAutoscroll').data('status') === 0) {
            scrollUpNotifications = false;
            $("#timsChatMessageTabMenu > .tabMenu > ul > li.ui-state-active").removeClass('notify');
            $(".timsChatMessageContainer.active").removeClass('notify');
            return $('#timsChatAutoscroll').click();
          }
        }
      }
    };
    handleUsers = function(users) {
      var foundUsers, user, _fn, _i, _len;
      foundUsers = {};
      userList.current = {};
      _fn = function(user) {
        var element, id, li, menu;
        userList.current[user.userID] = userList.allTime[user.userID] = user;
        id = "timsChatUser" + user.userID;
        if ($.wcfIsset(id)) {
          console.log("Moving User: '" + user.username + "'");
          element = $("#" + id).detach();
          if (user.awayStatus != null) {
            element.addClass('away');
            element.attr('title', user.awayStatus);
          } else {
            element.removeClass('away');
            element.removeAttr('title');
            element.data('tooltip', '');
          }
          if (user.suspended) {
            element.addClass('suspended');
          } else {
            element.removeClass('suspended');
          }
          $('#timsChatUserList > ul').append(element);
        } else {
          console.log("Inserting User: '" + user.username + "'");
          li = $('<li></li>');
          li.attr('id', id);
          li.addClass('timsChatUser');
          li.addClass('jsTooltip');
          if (user.userID === WCF.User.userID) {
            li.addClass('you');
          }
          if (user.suspended) {
            li.addClass('suspended');
          }
          if (user.awayStatus != null) {
            li.addClass('away');
            li.attr('title', user.awayStatus);
          }
          li.data('username', user.username);
          li.append(v.userTemplate.fetch(user));
          menu = $(v.userMenuTemplate.fetch({
            user: user,
            room: roomList.active
          }));
          if (menu.find('li').length) {
            li.append(menu);
            menu.addClass('dropdownMenu');
            li.addClass('dropdown');
          }
          li.appendTo($('#timsChatUserList > ul'));
        }
        return foundUsers[id] = true;
      };
      for (_i = 0, _len = users.length; _i < _len; _i++) {
        user = users[_i];
        _fn(user);
      }
      $('.timsChatUser').each(function() {
        if (foundUsers[$(this).attr('id')] == null) {
          console.log("Removing User: '" + ($(this).data('username')) + "'");
          WCF.Dropdown.removeDropdown($(this).attr('id'));
          return $(this).remove();
        }
      });
      return $('#toggleUsers .badge').text($('.timsChatUser').length);
    };
    insertText = function(text, options) {
      var maxLength;
      if (options == null) {
        options = {};
      }
      if ((options.prepend != null) && options.prepend && (options.append == null)) {
        options.append = false;
      }
      options = $.extend({
        prepend: false,
        append: true,
        submit: false
      }, options);
      if (options.prepend) {
        text = text + $('#timsChatInput').val();
      }
      if (options.append) {
        text = $('#timsChatInput').val() + text;
      }
      maxLength = $('#timsChatInput').attr('maxlength');
      if ((maxLength != null) && text.length > maxLength) {
        return;
      }
      $('#timsChatInput').val(text);
      $('#timsChatInput').trigger('change');
      if (options.submit) {
        return $('#timsChatForm').submit();
      } else {
        return $('#timsChatInput').focus();
      }
    };
    notify = function(message) {
      var content, id, title, _ref;
      if (message.sender === WCF.User.userID) {
        return;
      }
      if (scrollUpNotifications) {
        $("#timsChatMessageTabMenu > .tabMenu > ul > li.ui-state-active").addClass('notify');
        $(".timsChatMessageContainer.active").addClass('notify');
      }
      if (message.isInPrivateChannel) {
        id = message.sender === WCF.User.userID ? message.receiver : message.sender;
        if ($('.timsChatMessageContainer.active').data('userID') !== id) {
          $("#timsChatMessageTabMenuAnchor" + id).parent().addClass('notify');
          $("#timsChatMessageContainer" + id).addClass('notify');
        }
      } else if ($('.timsChatMessageContainer.active').data('userID') !== 0) {
        $("#timsChatMessageTabMenuAnchor0").parent().addClass('notify');
        $("#timsChatMessageContainer0").addClass('notify');
      }
      if (isActive || $('#timsChatNotify').data('status') === 0) {
        return;
      }
      document.title = v.titleTemplate.fetch($.extend({}, roomList.active, {
        newMessageCount: ++newMessageCount
      }));
      title = WCF.Language.get('chat.global.notify.title');
      content = "" + message.username + message.separator + " " + message.message;
      if (((_ref = window.Notification) != null ? _ref.permission : void 0) === 'granted') {
        return (function() {
          var notification;
          notification = new window.Notification(title, {
            body: content,
            onclick: function() {
              return notification.close();
            }
          });
          return setTimeout(function() {
            return notification.close();
          }, 5e3);
        })();
      }
    };
    refreshRoomList = function() {
      console.log('Refreshing the roomlist');
      return new WCF.Action.Proxy({
        autoSend: true,
        data: {
          actionName: 'getRoomList',
          className: 'chat\\data\\room\\RoomAction'
        },
        showLoadingOverlay: false,
        suppressErrors: true,
        success: function(data) {
          var a, li, room, _i, _len, _ref, _ref1;
          roomList = {
            active: {},
            available: {}
          };
          $('.timsChatRoom').remove();
          $('#toggleRooms .badge').text(data.returnValues.length);
          _ref = data.returnValues;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            room = _ref[_i];
            roomList.available[room.roomID] = room;
            if (room.active) {
              roomList.active = room;
            }
            li = $('<li></li>');
            li.addClass('timsChatRoom');
            if (room.active) {
              li.addClass('active');
            }
            a = $("<a href=\"" + room.link + "\">" + (WCF.String.escapeHTML(room.title)) + "</a>");
            a.data('roomID', room.roomID);
            a.appendTo(li);
            $("<span class=\"badge\">" + (WCF.String.formatNumeric(room.userCount)) + "</span>").appendTo(li);
            $('#timsChatRoomList ul').append(li);
          }
          if (((_ref1 = window.history) != null ? _ref1.replaceState : void 0) != null) {
            $('.timsChatRoom a').click(function(event) {
              var target;
              event.preventDefault();
              target = $(this);
              if (target.data('roomID') === roomList.active.roomID) {
                return;
              }
              window.history.replaceState({}, '', target.attr('href'));
              join(target.data('roomID'));
              $('#timsChatRoomList .active').removeClass('active');
              return target.parent().addClass('active');
            });
          }
          return console.log("Found " + data.returnValues.length + " rooms");
        }
      });
    };
    showError = function(text) {
      var errorDialog, formSubmit, reloadButton;
      if (errorVisible) {
        return;
      }
      errorVisible = true;
      loading = true;
      pe.refreshRoomList.stop();
      pe.getMessages.stop();
      errorDialog = $("<div id=\"timsChatLoadingErrorDialog\">\n	<p>" + text + "</p>\n</div>").appendTo('body');
      formSubmit = $("<div class=\"formSubmit\"></div>").appendTo(errorDialog);
      reloadButton = $("<button class=\"buttonPrimary\">" + (WCF.Language.get('chat.error.reload')) + "</button>").appendTo(formSubmit);
      reloadButton.on('click', function() {
        return window.location.reload();
      });
      return $('#timsChatLoadingErrorDialog').wcfDialog({
        closable: false,
        title: WCF.Language.get('wcf.global.error.title')
      });
    };
    join = function(roomID) {
      if (isJoining || roomID === roomList.active.roomID) {
        return;
      }
      isJoining = true;
      $('#timsChatInput').disable();
      loading = true;
      return new WCF.Action.Proxy({
        autoSend: true,
        data: {
          actionName: 'join',
          className: 'chat\\data\\room\\RoomAction',
          parameters: {
            roomID: roomID
          }
        },
        success: function(data) {
          loading = false;
          roomList.active = data.returnValues;
          if (openChannel === 0) {
            $('#timsChatTopic > .topic').text(roomList.active.topic);
            if (roomList.active.topic.trim() === '' || (hiddenTopics[roomList.active.roomID] != null)) {
              $('#timsChatTopic').addClass('invisible');
            } else {
              $('#timsChatTopic').removeClass('invisible');
            }
          }
          $('.timsChatMessage').addClass('unloaded');
          document.title = v.titleTemplate.fetch(roomList.active);
          handleMessages(roomList.active.messages);
          getMessages();
          refreshRoomList();
          return $('#timsChatInput').enable().focus();
        },
        failure: function(data) {
          return showError(WCF.Language.get('chat.error.join', data));
        },
        after: function() {
          return isJoining = false;
        }
      });
    };
    openPrivateChannel = function(userID) {
      var anchor, avatar, div, li;
      userID = parseInt(userID);
      console.log("Opening private channel " + userID);
      if (!$.wcfIsset("timsChatMessageContainer" + userID)) {
        if (userList.allTime[userID] == null) {
          return;
        }
        div = $('<div>');
        div.attr('id', "timsChatMessageContainer" + userID);
        div.data('userID', userID);
        div.addClass('tabMenuContent');
        div.addClass('timsChatMessageContainer');
        div.addClass('container');
        div.addClass('containerPadding');
        div.wrapInner("<ul></ul>");
        div.on('scroll', function(event) {
          event.stopPropagation();
          return handleScroll(event);
        });
        $('#timsChatMessageContainer0').after(div);
        $('.timsChatMessageContainer').height($('.timsChatMessageContainer').height());
      }
      if (userID !== 0) {
        if (hidePrivateChannelTopic) {
          $('#timsChatTopic').addClass('invisible');
        } else {
          $('#timsChatTopic').removeClass('invisible');
        }
        $('#timsChatTopic > .topic').html(WCF.Language.get('chat.global.privateChannelTopic', {
          username: userList.allTime[userID].username
        }));
        $('#timsChatMessageTabMenu').removeClass('singleTab');
        if (!$.wcfIsset("timsChatMessageTabMenuAnchor" + userID)) {
          li = $('<li>');
          anchor = $("<a id=\"timsChatMessageTabMenuAnchor" + userID + "\" class=\"timsChatMessageTabMenuAnchor\" href=\"" + (window.location.toString().replace(/#.+$/, '')) + "#timsChatMessageContainer" + userID + "\" />");
          anchor.data('userID', userID);
          avatar = $(userList.allTime[userID].avatar[16]);
          avatar = $('<span class="userAvatar framed" />').wrapInner(avatar);
          avatar.append("<span>" + (WCF.String.escapeHTML(userList.allTime[userID].username)) + "</span>");
          anchor.wrapInner(avatar);
          anchor.prepend('<span class="icon icon16 icon-warning-sign notifyIcon"></span>');
          anchor.append("<span class=\"jsChannelCloser icon icon16 icon-remove jsTooltip\" title=\"" + (WCF.Language.get('chat.global.closePrivateChannel')) + "\" />");
          li.append(anchor);
          $('#timsChatMessageTabMenu > .tabMenu > ul').append(li);
          $('#timsChatMessageTabMenu').wcfTabs('refresh');
          WCF.System.FlexibleMenu.rebuild($('#timsChatMessageTabMenu > .tabMenu').attr('id'));
        }
        $('#timsChatUpload').parent().hide();
      } else {
        $('#timsChatTopic > .topic').text(roomList.active.topic);
        if (roomList.active.topic.trim() === '' || (hiddenTopics[roomList.active.roomID] != null)) {
          $('#timsChatTopic').addClass('invisible');
        } else {
          $('#timsChatTopic').removeClass('invisible');
        }
        $('#timsChatUpload').parent().show();
      }
      $('.timsChatMessageContainer').removeClass('active');
      $("#timsChatMessageContainer" + userID).addClass('active');
      $("#timsChatMessageTabMenuAnchor" + userID).parent().removeClass('notify');
      $("#timsChatMessageContainer" + userID).removeClass('notify');
      $("#timsChatMessageContainer" + userID).trigger('scroll');
      $('#timsChatMessageTabMenu').wcfTabs('select', $("#timsChatMessageTabMenuAnchor" + userID).parent().index());
      WCF.DOMNodeInsertedHandler.execute();
      $(window).resize();
      return openChannel = userID;
    };
    closePrivateChannel = function(userID) {
      if (userID !== 0) {
        $("#timsChatMessageTabMenuAnchor" + userID).parent().remove();
        $("#timsChatMessageContainer" + userID).remove();
        $('#timsChatMessageTabMenu').wcfTabs('refresh');
        WCF.System.FlexibleMenu.rebuild($('#timsChatMessageTabMenu > .tabMenu').wcfIdentify());
      }
      if ($('#timsChatMessageTabMenu > .tabMenu > ul > li').length <= 1) {
        $('#timsChatMessageTabMenu').addClass('singleTab');
      }
      return openPrivateChannel(0);
    };
    clearChannel = function(userID) {
      $("#timsChatMessageContainer" + userID + " .timsChatMessage").remove();
      return $("#timsChatMessageContainer" + userID).scrollTop($("#timsChatMessageContainer" + userID).prop('scrollHeight'));
    };
    addListener = function(event, callback) {
      if (events[event] == null) {
        return false;
      }
      events[event].add(callback);
      return true;
    };
    removeListener = function(event, callback) {
      if (events[event] == null) {
        return false;
      }
      events[event].remove(callback);
      return true;
    };
    if (((typeof WCF !== "undefined" && WCF !== null ? (_ref = WCF.Attachment) != null ? _ref.Upload : void 0 : void 0) != null) && $('#timsChatUploadContainer').length) {
      Attachment = WCF.Attachment.Upload.extend({
        fileUploaded: false,
        init: function() {
          var css, label, parent;
          this._super($('#timsChatUploadContainer'), $(false), 'be.bastelstu.chat.message', 0, 0, 0, 1, null);
          if (!this._supportsAJAXUpload) {
            $('#timsChatUploadDropdownMenu .uploadButton').click((function(_this) {
              return function() {
                return _this._showOverlay();
              };
            })(this));
          }
          label = $('#timsChatUploadDropdownMenu li > span > label');
          parent = label.parent();
          css = parent.css(['padding-top', 'padding-right', 'padding-bottom', 'padding-left']);
          label.css(css);
          label.css('margin', "-" + css['padding-top'] + " -" + css['padding-right'] + " -" + css['padding-bottom'] + " -" + css['padding-left']);
          return $('#timsChatUpload').click(function() {
            $('#timsChatUpload > span.icon-ban-circle').removeClass('icon-ban-circle').addClass('icon-paper-clip');
            return $('#timsChatUploadContainer .innerError').remove();
          });
        },
        _createButton: function() {
          if (this._supportsAJAXUpload) {
            this._fileUpload = $("<input id=\"timsChatUploadInput\" type=\"file\" name=\"" + this._name + "\" />");
            this._fileUpload.change((function(_this) {
              return function() {
                return _this._upload();
              };
            })(this));
            return this._fileUpload.appendTo('body');
          }
        },
        _removeButton: function() {
          return this._fileUpload.remove();
        },
        _getParameters: function() {
          this._tmpHash = Math.random();
          this._parentObjectID = roomList.active.roomID;
          return this._super();
        },
        _upload: function() {
          var files;
          files = this._fileUpload.prop('files');
          if (files.length) {
            $('#timsChatUpload > span.icon').removeClass('icon-paper-clip icon-ban-circle').addClass('icon-spinner');
            return this._super();
          }
        },
        _insert: function(event) {
          var objectID;
          objectID = $(event.currentTarget).data('objectID');
          return new WCF.Action.Proxy({
            autoSend: true,
            data: {
              actionName: 'sendAttachment',
              className: 'chat\\data\\message\\MessageAction',
              parameters: {
                objectID: objectID,
                tmpHash: this._tmpHash,
                parentObjectID: 1
              }
            },
            showLoadingOverlay: false,
            success: function() {
              $('#timsChatUploadDropdownMenu .jsDeleteButton').parent().remove();
              $('#timsChatUploadDropdownMenu .sendAttachmentButton').remove();
              $('#timsChatUploadDropdownMenu .uploadButton').show();
              $('#timsChatUpload > span.icon').removeClass('icon-ok-sign').addClass('icon-paper-clip');
              return fileUploaded = false;
            },
            failure: function(data) {
              return false;
            }
          });
        },
        _initFile: function(file) {
          var li;
          li = $("<li class=\"uploadProgress\">\n	<span>\n		<progress max=\"100\"></progress>\n	</span>\n</li>").data('filename', file.name);
          $('#timsChatUploadDropdownMenu').append(li);
          $('#timsChatUploadDropdownMenu .uploadButton').hide();
          if (this._buttonSelector.data('maxSize') < file.size) {
            li.find('progress').remove();
            $('#timsChatUpload > span.icon-spinner').removeClass('icon-spinner').addClass('icon-ban-circle');
            $('#timsChatUpload').addClass('uploadFailed').after("<small class=\"innerError\">" + (WCF.Language.get('wcf.attachment.upload.error.tooLarge')) + "</small>");
            this._error();
            li.addClass('uploadFailed');
          }
          return li;
        },
        _validateLimit: function() {
          var innerError;
          innerError = this._buttonSelector.next('small.innerError');
          if (fileUploaded) {
            if (!innerError.length) {
              innerError = $('<small class="innerError" />').insertAfter('#timsChatUpload');
            }
            innerError.html(WCF.Language.get('wcf.attachment.upload.error.reachedLimit'));
            innerError.css('position', 'absolute');
            return false;
          }
          innerError.remove();
          return true;
        },
        _success: function(uploadID, data) {
          var deleteButton, errorMessage, filename, internalFileID, li, link, _i, _len, _ref1;
          _ref1 = this._uploadMatrix[uploadID];
          for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
            li = _ref1[_i];
            li.find('progress').remove();
            li.removeClass('uploadProgress').addClass('sendAttachmentButton');
            li.find('span').addClass('box32').append("<div class=\"framed attachmentImageContainer\">\n	<span class=\"attachmentTinyThumbnail icon icon32 icon-paper-clip\"></span>\n</div>\n<div class=\"containerHeaderline\">\n	<p></p>\n	<small></small>\n	<p>" + (WCF.Language.get('wcf.global.button.submit')) + "</p>\n</div>");
            li.click((function(_this) {
              return function(event) {
                return _this._insert(event);
              };
            })(this));
            filename = li.data('filename');
            internalFileID = li.data('internalFileID');
            if (data.returnValues && data.returnValues.attachments[internalFileID]) {
              if (data.returnValues.attachments[internalFileID].tinyURL) {
                li.find('.box32 > div.attachmentImageContainer > .icon-paper-clip').replaceWith($("<img src=\"" + data.returnValues.attachments[internalFileID].tinyURL + "'\" alt=\"\" class=\"attachmentTinyThumbnail\" style=\"width: 32px; height: 32px;\" />"));
              }
              link = $('<a href="" class="jsTooltip"></a>');
              link.attr({
                'href': data.returnValues.attachments[internalFileID].url,
                'title': filename
              });
              if (parseInt(data.returnValues.attachments[internalFileID].isImage) !== 0) {
                link.addClass('jsImageViewer');
                if (!data.returnValues.attachments[internalFileID].tinyURL) {
                  li.find('.box32 > div.attachmentImageContainer > .icon-paper-clip').replaceWith($("<img src=\"" + data.returnValues.attachments[internalFileID].url + "'\" alt=\"\" class=\"attachmentTinyThumbnail\" style=\"width: 32px; height: 32px;\" />"));
                }
              }
              li.find('.attachmentTinyThumbnail').wrap(link);
              li.find('small').append(data.returnValues.attachments[internalFileID].formattedFilesize);
              li.data('objectID', data.returnValues.attachments[internalFileID].attachmentID);
              deleteButton = $("<li>\n	<span class=\"jsDeleteButton\" data-object-id=\"" + data.returnValues.attachments[internalFileID].attachmentID + "\" data-confirm-message=\"" + (WCF.Language.get('wcf.attachment.delete.sure')) + "\">\n		<span class=\"icon icon16 icon-remove pointer jsTooltip\" />\n		<span>" + (WCF.Language.get('wcf.global.button.delete')) + "</span>\n	</span>\n</li>");
              li.parent().append(deleteButton);
              fileUploaded = true;
            } else {
              $('#timsChatUpload .icon-spinner').removeClass('icon-spinner').addClass('icon-ban-circle');
              if (data.returnValues && data.returnValues.errors[internalFileID]) {
                errorMessage = data.returnValues.errors[internalFileID].errorType;
              } else {
                errorMessage = 'uploadFailed';
              }
              $('#timsChatUpload').addClass('uploadFailed').after("<small class=\"innerError\">" + (WCF.Language.get('wcf.attachment.upload.error.' + errorMessage)) + "</small>");
              $('#timsChatUploadDropdownMenu .sendAttachmentButton').remove();
              $('#timsChatUploadDropdownMenu .uploadButton').show();
              fileUploaded = false;
            }
          }
          WCF.DOMNodeInsertedHandler.execute();
          $('#timsChatUpload > span.icon').removeClass('icon-spinner').addClass('icon-ok-sign');
          $('#timsChatUploadDropdownMenu .uploadProgress').remove();
          return $('#timsChatUploadDropdownMenu .sendAttachmentButton').show();
        },
        _error: function(jqXHR, textStatus, errorThrown) {
          $('#timsChatUpload > .icon-spinner').removeClass('icon-spinner').addClass('icon-ban-circle');
          if (!$('#timsChatUpload').hasClass('uploadFailed')) {
            $('#timsChatUpload').addClass('uploadFailed').after("<small class=\"innerError\">" + (WCF.Language.get('wcf.attachment.upload.error.uploadFailed')) + "</small>");
          }
          $('#timsChatUploadDropdownMenu .uploadProgress').remove();
          $('#timsChatUploadDropdownMenu .uploadButton').show();
          return fileUploaded = false;
        }
      });
      Action = {};
      Action.Delete = WCF.Action.Delete.extend({
        triggerEffect: function(objectIDs) {
          var container, index, self, _i, _len, _ref1;
          _ref1 = this._containers;
          for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
            index = _ref1[_i];
            container = $("#" + index);
            if (WCF.inArray(container.find(this._buttonSelector).data('objectID'), objectIDs)) {
              self = this;
              container.wcfBlindOut('up', function(event) {
                var parent;
                parent = $(this).parent();
                $(this).remove();
                parent.find('.sendAttachmentButton').remove();
                parent.find('.uploadButton').show();
                $('#timsChatUpload > .icon-ok-sign').removeClass('icon-ok-sign').addClass('icon-paper-clip');
                self._containers.splice(self._containers.indexOf($(this).wcfIdentify(), 1));
                return self._didTriggerEffect($(this));
              });
              fileUploaded = false;
            }
          }
        }
      });
    }
    Chat = {
      init: init,
      getMessages: getMessages,
      getMarkedMessages: function() {
        return JSON.parse(JSON.stringify(markedMessages));
      },
      getUserList: function() {
        return JSON.parse(JSON.stringify(userList));
      },
      getRoomList: function() {
        return JSON.parse(JSON.stringify(roomList));
      },
      refreshRoomList: refreshRoomList,
      insertText: insertText,
      freeTheFish: freeTheFish,
      join: join,
      listener: {
        add: addListener,
        remove: removeListener
      }
    };
    if (Attachment != null) {
      Chat.Attachment = Attachment;
    }
    if (Attachment != null) {
      Chat.Action = Action;
    }
    if (window.be == null) {
      window.be = {};
    }
    if (be.bastelstu == null) {
      be.bastelstu = {};
    }
    return window.be.bastelstu.Chat = Chat;
  })(jQuery, this);

}).call(this);
